<?php
/** 
 *  PHP Version 5
 *
 *  @category    Amazon
 *  @package     Amazon_FPS
 *  @copyright   Copyright 2008 Amazon Technologies, Inc.
 *  @link        http://aws.amazon.com
 *  @license     http://aws.amazon.com/apache2.0  Apache License, Version 2.0
 *  @version     2008-09-17
 */
/******************************************************************************* 
 *    __  _    _  ___ 
 *   (  )( \/\/ )/ __)
 *   /__\ \    / \__ \
 *  (_)(_) \/\/  (___/
 * 
 *  Amazon FPS PHP5 Library
 *  Generated: Wed Jan 28 05:41:24 PST 2009
 * 
 */

/**
 *  @see Amazon_FPS_Model
 */
require_once ('Amazon/FPS/Model.php');  

    

/**
 * Amazon_FPS_Model_GetOutstandingDebtBalanceResult
 * 
 * Properties:
 * <ul>
 * 
 * <li>OutstandingDebt: Amazon_FPS_Model_OutstandingDebtBalance</li>
 *
 * </ul>
 */ 
class Amazon_FPS_Model_GetOutstandingDebtBalanceResult extends Amazon_FPS_Model
{


    /**
     * Construct new Amazon_FPS_Model_GetOutstandingDebtBalanceResult
     * 
     * @param mixed $data DOMElement or Associative Array to construct from. 
     * 
     * Valid properties:
     * <ul>
     * 
     * <li>OutstandingDebt: Amazon_FPS_Model_OutstandingDebtBalance</li>
     *
     * </ul>
     */
    public function __construct($data = null)
    {
        $this->_fields = array (
        'OutstandingDebt' => array('FieldValue' => null, 'FieldType' => 'Amazon_FPS_Model_OutstandingDebtBalance'),
        );
        parent::__construct($data);
    }

        /**
     * Gets the value of the OutstandingDebt.
     * 
     * @return OutstandingDebtBalance OutstandingDebt
     */
    public function getOutstandingDebt() 
    {
        return $this->_fields['OutstandingDebt']['FieldValue'];
    }

    /**
     * Sets the value of the OutstandingDebt.
     * 
     * @param OutstandingDebtBalance OutstandingDebt
     * @return void
     */
    public function setOutstandingDebt($value) 
    {
        $this->_fields['OutstandingDebt']['FieldValue'] = $value;
        return;
    }

    /**
     * Sets the value of the OutstandingDebt  and returns this instance
     * 
     * @param OutstandingDebtBalance $value OutstandingDebt
     * @return Amazon_FPS_Model_GetOutstandingDebtBalanceResult instance
     */
    public function withOutstandingDebt($value)
    {
        $this->setOutstandingDebt($value);
        return $this;
    }


    /**
     * Checks if OutstandingDebt  is set
     * 
     * @return bool true if OutstandingDebt property is set
     */
    public function isSetOutstandingDebt()
    {
        return !is_null($this->_fields['OutstandingDebt']['FieldValue']);

    }




}