<?php
/** 
 *  PHP Version 5
 *
 *  @category    Amazon
 *  @package     Amazon_FPS
 *  @copyright   Copyright 2008 Amazon Technologies, Inc.
 *  @link        http://aws.amazon.com
 *  @license     http://aws.amazon.com/apache2.0  Apache License, Version 2.0
 *  @version     2008-09-17
 */
/******************************************************************************* 
 *    __  _    _  ___ 
 *   (  )( \/\/ )/ __)
 *   /__\ \    / \__ \
 *  (_)(_) \/\/  (___/
 * 
 *  Amazon FPS PHP5 Library
 *  Generated: Wed Jan 28 05:41:24 PST 2009
 * 
 */

/**
 *  @see Amazon_FPS_Model
 */
require_once ('Amazon/FPS/Model.php');  

    

/**
 * Amazon_FPS_Model_GetTransactionResult
 * 
 * Properties:
 * <ul>
 * 
 * <li>Transaction: Amazon_FPS_Model_TransactionDetail</li>
 *
 * </ul>
 */ 
class Amazon_FPS_Model_GetTransactionResult extends Amazon_FPS_Model
{


    /**
     * Construct new Amazon_FPS_Model_GetTransactionResult
     * 
     * @param mixed $data DOMElement or Associative Array to construct from. 
     * 
     * Valid properties:
     * <ul>
     * 
     * <li>Transaction: Amazon_FPS_Model_TransactionDetail</li>
     *
     * </ul>
     */
    public function __construct($data = null)
    {
        $this->_fields = array (
        'Transaction' => array('FieldValue' => null, 'FieldType' => 'Amazon_FPS_Model_TransactionDetail'),
        );
        parent::__construct($data);
    }

        /**
     * Gets the value of the Transaction.
     * 
     * @return TransactionDetail Transaction
     */
    public function getTransaction() 
    {
        return $this->_fields['Transaction']['FieldValue'];
    }

    /**
     * Sets the value of the Transaction.
     * 
     * @param TransactionDetail Transaction
     * @return void
     */
    public function setTransaction($value) 
    {
        $this->_fields['Transaction']['FieldValue'] = $value;
        return;
    }

    /**
     * Sets the value of the Transaction  and returns this instance
     * 
     * @param TransactionDetail $value Transaction
     * @return Amazon_FPS_Model_GetTransactionResult instance
     */
    public function withTransaction($value)
    {
        $this->setTransaction($value);
        return $this;
    }


    /**
     * Checks if Transaction  is set
     * 
     * @return bool true if Transaction property is set
     */
    public function isSetTransaction()
    {
        return !is_null($this->_fields['Transaction']['FieldValue']);

    }




}