<?php
session_start();
?>
<html>
<body>
<pre>
<?php
set_include_path(get_include_path() . PATH_SEPARATOR .dirname(__FILE__).'/amazon-fps/src');
include_once('amazon-fps/src/Amazon/FPS/Samples/.config.inc.php');

/************************************************************************
 * Instantiate Implementation of Amazon FPS
 * 
 * AWS_ACCESS_KEY_ID and AWS_SECRET_ACCESS_KEY constants 
 * are defined in the .config.inc.php located in the same 
 * directory as this sample
 ***********************************************************************/

 
/************************************************************************
 * Uncomment to try out Mock Service that simulates Amazon_FPS
 * responses without calling Amazon_FPS service.
 *
 * Responses are loaded from local XML files. You can tweak XML files to
 * experiment with various outputs during development
 *
 * XML files available under Amazon/FPS/Mock tree
 *
 ***********************************************************************/
 // $service = new Amazon_FPS_Mock();

/************************************************************************
 * Setup request parameters and uncomment invoke to try out 
 * sample for Pay Action
 ***********************************************************************/
 // @TODO: set request. Action can be passed as Amazon_FPS_Model_PayRequest
 // object or array of parameters
 // invokePay($service, $request);

                                                                                            
/**
  * Pay Action Sample
  * 
  * Allows calling applications to move money from a sender to a recipient.
  *   
  * @param Amazon_FPS_Interface $service instance of Amazon_FPS_Interface
  * @param mixed $request Amazon_FPS_Model_Pay or array of parameters
  */
 function invokePay(Amazon_FPS_Interface $service, $request) 
 {
     try {
             $response = $service->pay($request);
             
               echo ("Service Response\n");
               echo ("=============================================================================\n");

               echo("        PayResponse\n");
               if ($response->isSetPayResult()) { 
                   echo("            PayResult\n");
                   $payResult = $response->getPayResult();
                   if ($payResult->isSetTransactionId()) 
                   {
                       echo("                TransactionId\n");
                       echo("                    " . $payResult->getTransactionId() . "\n");
                   }
                   if ($payResult->isSetTransactionStatus()) 
                   {
                       echo("                TransactionStatus\n");
                       echo("                    " . $payResult->getTransactionStatus() . "\n");
                       //CHECK Transaction Status is Success
                       $_SESSION['status'] = 'OK';
                   }
               } 
               if ($response->isSetResponseMetadata()) { 
                   echo("            ResponseMetadata\n");
                   $responseMetadata = $response->getResponseMetadata();
                   if ($responseMetadata->isSetRequestId()) 
                   {
                       echo("                RequestId\n");
                       echo("                    " . $responseMetadata->getRequestId() . "\n");
                   }
               } 

    } catch (Amazon_FPS_Exception $ex) {
        echo("Caught Exception: " . $ex->getMessage() . "\n");
        echo("Response Status Code: " . $ex->getStatusCode() . "\n");
        echo("Error Code: " . $ex->getErrorCode() . "\n");
        echo("Error Type: " . $ex->getErrorType() . "\n");
        echo("Request ID: " . $ex->getRequestId() . "\n");
        echo("XML: " . $ex->getXML() . "\n");
    }
}

function validateQueryString()
{
    echo "validing the query string now\n";
    $querystring = $_SERVER['QUERY_STRING'];
    echo $_GET['signature'];
    $obj = new Amazon_FPS_CBUIUtils(AWS_ACCESS_KEY_ID,AWS_SECRET_ACCESS_KEY);
    //Original signature received in response from Amazon FPS should be specified.
    $signatureMatched = $obj->validateQueryString($querystring,$_GET['signature']);

    if ($signatureMatched) {
        echo "signature matched \n";
		$request =  new Amazon_FPS_Model_PayRequest();
		//set the proper senderToken here.
		$request->setSenderTokenId($_GET['tokenID']);
		$amount = new Amazon_FPS_Model_Amount();
		$amount->setCurrencyCode("USD");
		//set the transaction amount here;
		$amount->setValue($_SESSION['transaction_amount']); 
		$request->setTransactionAmount($amount);
		//set the unique caller reference here.
		$request->setCallerReference($_GET['callerReference']); 
		$service = new Amazon_FPS_Client(AWS_ACCESS_KEY_ID, 
	                                       AWS_SECRET_ACCESS_KEY);
	  	invokePay($service, $request);
    }
    else
        echo "Signature did not match \n";
}
validateQueryString();

              
?>
</pre>
<script type="text/javascript">
	function gotoflex() {
		window.opener.window.document.getElementById('amazonFlex').paymentNotification();
		window.close();
	}
</script>
<form>
<input type="button" value="Close This Window and Return to Flex APP" onclick="gotoflex()"/>
</form>
</body>
</html>